use rand::Rng;

const CELL_COUNT : usize = 25;

fn main()
{
    let mut random_number_generator = rand::thread_rng();

    let mut maze_array = [[0; CELL_COUNT]; CELL_COUNT];

    for n in 0..CELL_COUNT
    {
        maze_array[n             ][0           ] = 1; // 위쪽 벽
        maze_array[0             ][n           ] = 1; // 왼쪽 벽
        maze_array[n             ][CELL_COUNT-1] = 1; // 오른쪽 벽
        maze_array[CELL_COUNT - 1][n           ] = 1; // 아래쪽 벽
    }

    for y in 2..CELL_COUNT - 2
    {
        for x in 2..CELL_COUNT - 2
        {
            if x % 2 == 1 || y % 2 == 1
            {
                continue;
            }

            maze_array[y][x] = 1; // 벽

            let random_number = random_number_generator.gen_range(0..=3);

            match random_number
            {
                0 => maze_array[y - 1][x    ] = 1, // 상
                1 => maze_array[y + 1][x    ] = 1, // 하
                2 => maze_array[y    ][x - 1] = 1, // 좌
                3 => maze_array[y    ][x + 1] = 1, // 우
                _ => {},
            }
        }
    }

    let tile_array = ["  ", "##"];

    for y in 0..CELL_COUNT
    {
        for x in 0..CELL_COUNT
        {
            print!("{}", tile_array[maze_array[y][x]]);
        }

        println!("");
    }
}